<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html>
    <head>
        <title>Vulnerabilidades </title>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">       
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.0/jquery.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
         <link rel="stylesheet" type="text/css" href="style/body.css">
         <link rel="shortcut icon" type="image/png" href="images/UVA.png"/>
    </head>
    <body >  
        <nav class="navbar navbar-inverse navbar-fixed-top">         
            <div class="container">
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar"></button>
                    
                    <a class="navbar-left" href="#"><img src="images/UVA.png" witdth="10%" height="10%"></a>
                             
                </div>
                <div id="navbar" class="collapse navbar-collapse navbar-right">
                    <ul class="nav navbar-nav ">
                        <li><a data-toggle="modal" data-target="#myModal">About</a></li>
                    </ul>
                </div>
            </div>             
        </nav>        
        <br><br>
        
        <div class="container">
            <br>
            <h1>Vulnerabilidades</h1>
            <br>
            <div role="tabpanel">
                <ul class="nav nav-tabs" role="tablist">
                    <li class="active" role="presentation"><a href="#estadoRed" data-toggle="tab" role="tab">Estado de la red</a></li>
                    <li role="presentation"><a href="#vulnerabilidades" data-toggle="tab" role="tab">Escaneo de vulnerabilidades</a></li>
                    <li role="presentation"><a href="#fuerzaBruta" data-toggle="tab" role="tab"> Fuerza Bruta</a></li>
                    <li role="presentation"><a href="#DoS" data-toggle="tab" role="tab"> Denegacin de servicio</a></li>
                    <li role="presentation"><a href="#escaneopuertos" data-toggle="tab" role="tab">Escaneo de puertos</a></li>
                    <li role="presentation"><a href="#spoofing" data-toggle="tab" role="tab">Spoofing</a></li>
                </ul>
            
                <div class="tab-content">
                    <div role="tabpanel" class="tab-pane fade in active" id="estadoRed">
                        <h2>Estado de la red</h2>
                        <iframe src="http://157.88.123.102:80/app/kibana#/dashboard/ca480720-2fdf-11e7-9d02-3f49bde5c1d5?embed=true&_g()"height="800" width="100%"></iframe>
                        <br>
                        <footer class="panel-footer">Universidad de Valladolid. Trabajo de fin de grado realizado por D. Sergio Sanz Ferrero y Dr. Jess M Vegas Hernndez</footer>
                        
                    </div>
                    
                    <div role="tabpanel" class="tab-pane fade" id="vulnerabilidades">
                        <h2>Escaneo de vulnerabilidades</h2>
                        <br>
                        <p>Existen herramientas muy similares como OpenVas o Nessus que nos permiten hacer un escaneo automatizado de vulnerabilidades. En este caso nos centraremos en Nessus, aunque ambos son muy parecidos de utilizar. </p>
                        <br>                      
                        <p>Consideraremos este tipo de herramientas como una primera aproximacin a explotar un sistema o a auditar nuestra propia seguridad. Aunque en el resultado de este escaneo no se detecten vulnerabilidades, no quiere decir que no existan. Deberemos realizar anlisis ms complejos. </p>
                        <br>
                        <p>Los parmetros de configuracin de un escaneo Nessus son los siguientes </p>      
                        <p> 
                            <ul type="square">
                                <li>Basic: para especificar aspectos bsicos organizativos, incluyendo nombre y descripcin del escaneo. </li>
                                <li>Discovery: para establecer el descubrimiento y la exploracin de puertos, incluyendo los rangos y los mtodos. </li>
                                <li>Assessment: para identificar malware, vulnerabilidades de fuerza bruta, y la susceptibilidad de un sistema web. </li>
                                <li>Report: el procesamiento y la salida del escaneo. </li>
                                <li>Advanced: otros parmetros para hacer ms eficiente un escaneo. </li>
                            </ul>
                        </p>
                        <br>
                        <h4>Metasploit</h4>                    
                        <p> Metasploit es un software gratuito y open-source que puede ser usado para automatizar tareas complejas. MSFConsole es la interfaz ms popular de este framework y ser con la que interactuemos para lanzar exploits aprovechando las vulnerabilidades. </p>
                        <br>
                        <p> Tras haber usado Nessus para realizar un escaneo de vulnerabilidades, Mestasploit nos ofrece la posibilidad de lanzar exploits para explotar esas vulnerabilidades.  El problema de lanzar todos estos exploits es que se generar mucho ruido y se podr detectar fcilmente. Por ello, este tipo de ataques se suelen realizar cuando se dispone de poco tiempo o simplemente se quiere auditar la seguridad.</p>
                        
                        
                        <div class="table-responsive">  
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Lanzamiento</th>                                
                                    </tr>   
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>
                                            Para lanzar el escaneo, lo primero que necesitaremos ser disponer del software, el cul se puede descargar desde la <a href="https://www.tenable.com/downloads/nessus"> pgina oficial</a>.
                                            <br><br>  
                                            Una vez instalado, seleccionaremos los plugings que deseemos. En este apartado tendremos una lista de vulnerabilidades, podremos habilitar familias de plugins o plugins individuales para llevar a cabo. 
                                           <br><br>                                       
                                            Una vez configurado todos los parmetros del escaneo, procedemos a definir cul ser nuestro objetivo, en este caso la IP 157.88.123.102 y a lanzarlo. Cuando haya finalizado el escaneo, podremos encontrar en reports las principales vulnerabilidades del sistema objetivo que hemos incluido. Podremos exportarlo en varios formatos. Si estamos realizando un test de penetracin, es recomendable exportarlo en formato .nessus para despus poder importarlo, por ejemplo, en Metasploit.
                                            <br><br> 
                                            Para importar los resultados del escaneo a Metasploit usaremos  MSFConsole, que es la interfaz ms popular de Metasploit y escribiremos:
                                            <br><br>                                            
                                            <code>msf > db_import ruta/.nessus #importa los resultados de Nessus<br>                                         
                                                msf > db_autopwn -x -p #lanzamiento de los exploits<br>                                         
                                                msf > sessions -l #consultar sesiones obtenidas<br></code>
                                            
                                            <br><br>
                                            De esta forma se lanzarn todos los exploits disponibles para explotar las vulnerabilidades encontradas, aunque esto generar mucho ruido. Si deseamos usar un exploit para explotar una vulnerabilidad concreta, a continuacin mostraremos un ejemplo de como lanzarlo:
                                            <br><br>
                                            <code>msf > search ssh #bsqueda de un exploit<br> 
                                                msf > use auxiliary/scanner/ssh/ssh_login #seleccin de un exploit<br> 
                                                msf auxiliary(ssh_login) > show options #muestra los parmetros<br> 
                                                msf auxiliary(ssh_login)> set RHOSTS 157.88.123.102 #establecimiento de parmetros<br> 
                                                msf auxiliary(ssh_login)> set USERPASS_FILE /usr/share/metasploit-framework/data/wordlists/root_userpass.txt # establecimiento de parmetros<br>                                               
                                                msf auxiliary(ssh_login) > run #ejecuta exploit<br></code> 
                                            
                                        </td>
                                    </tr>
                                </tbody>
                            </table>                          
                        </div>
                  
                        
               
                        
                        <div class="table-responsive">  
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Deteccin y defensa</th>                                
                                    </tr>   
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>                                      
                                            Podremos acceder a cada una de las vulnerabilidades, clasificadas segn el impacto que puedan tener en el sistema. Se incluye una descripcin, referencias a otros documentos de inters y soluciones para mitigarlas. 
                                            <br><br>
                                            Es recomendable lanzar este tipo de escaneos cuando se haya diseado y levantado una nueva red. Esto servir tanto para ataque como para conseguir informacin de las vulnerabilidades de nuestra red y poder protegernos ante ellas.   
                                            <br><br>
                                            Todo el trfico generado por este tipo de escaneos tiene su origen en el puerto 80. Esto es porque herramientas como Nessus u Openvas son usadas mediante la interfaz web. No quiere decir que siempre sea as, si lo lanzsemos mediante Metasploit el origen de los puertos no sera el 80. An as es un indicio de que se trata de un escaneo de vulnerabilidades. Las peticiones que se envan son a mltiples puertos, aunque los puertos que se encuentran abiertos y presentan vulnerabilidades recibirn ms trfico que otros.
                                                                         
                                        </td>
                                    </tr>
                                </tbody>
                            </table> 
                            <footer class="panel-footer">Universidad de Valladolid. Trabajo de fin de grado realizado por D. Sergio Sanz Ferrero y Dr. Jess M Vegas Hernndez</footer>
                        </div> 
            

                    </div>
                                       

               
                    <div role="tabpanel" class="tab-pane fade" id="fuerzaBruta">
                        <h2>Fuerza bruta</h2>
                        <br>
                        <form method="post" action="Controlador"><button name="lanzar" type="submit" value="fuerzabruta.sh" class="btn btn-primary active">Lanzar ataque</button></form>
                        <br>
                        <p>Un ataque de fuerza bruta consiste en que un atacante configure valores predeterminados, realice solicitudes a un servidor, utilizando esos valores y finalmente analice la respuesta. Hydra junto con Medusa son las dos herramientas que ms se utilizan para realizar este tipo de ataques, ambos son crackeadores de contraseas. Para realizar este ataque se usar un diccionario de contraseas que se generar mediante la herramienta Crunch.</p>
                        <br>
                        <p>No solo existen diccionarios de contraseas, tambin podremos encontrar diccionarios de usuarios o puertos. Cuanto menos especficos seamos, ms tiempo llevar el ataque e incluso se podra no llegar a completar en un perodo de tiempo aceptable.</p> 
                        <div class="table-responsive">  
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Lanzamiento</th>                                
                                    </tr>   
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>
                                            Para poder realizar un ataque de estas caractersticas, lo primero que supondremos es el formato de la contrasea. Existen multitud de diccionarios con las contraseas por defecto de muchos sistemas y las ms usadas por la gente, que en ciertos casos nos puede ahorrar mucho tiempo a la hora de llevar este tipo de ataques. 
                                            <br> <br>
                                            No solo existen diccionarios de contraseas, tambin podremos encontrar diccionarios de usuarios o puertos. Cuanto menos especficos seamos, ms tiempo llevar el ataque e incluso se podra no llegar a completar en un perodo de tiempo aceptable.
                                            <br> <br>
                                            Mediante la herramienta Crunch generaremos diccionarios contemplando todas las posibilidades. Si no usa una contrasea muy robusta, ser efectivo en un tiempo ms o menos razonable.
                                            <br> <br>
                                            Una vez que tenemos el diccionario de posibles contraseas, podemos proceder a lanzar el ataque de fuerza bruta hacia un servicio. Supondremos tambin que el usuario ser root, aunque tambin se podra hacer un diccionario de usuarios. Para lanzar el ataque, usaremos la herramienta Hydra.
                                            <br> <br>
                                            <code>$ hydra -l root -P diccionario.txt 157.88.123.102 ssh</code>                                          
                                        </td>
                                    </tr>
                                </tbody>
                            </table>                          
                        </div>
                        
                        <div class="table-responsive">  
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Deteccin y defensa</th>                                
                                    </tr>   
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>                                      
                                           Lo primero que debemos tener en cuenta es que estos ataques se realizan mediante diccionarios de usuarios y contraseas. Muchos de estos diccionarios suelen ser muy completos y se incluyen contraseas por defecto de dispositivos y contraseas habituales.
                                           <br><br>
                                           Por lo tanto un primer paso es tener una contrasea que no sea tan dbil ante estos ataques. Es recomendable usar contraseas largas, con letras, nmeros y otros caracteres. Llevar a cabo un ataque por fuerza bruta con una contrasea as, llevara varios das y sera fcilmente detectable.
                                           <br><br>
                                           Otra de las medidas que ayudan a mitigar este tipo de ataques, es cambiar el puerto defecto. As pues, ciertos servicios como SSH, que por defecto corren en el 22, son usualmente atacados por ataques automatizados. Aunque con un escaneo de puertos, se podra ver cules son los puertos que estn abiertos y los servicios que corren, muchos de estos ataques son ejecutados mediante scripts, que a menos que sean dirigidos, no utilizarn otro tipo de herramientas. Cambiar el puerto, por lo tanto, aumentara el tiempo para que tuviera xito el ataque.
                                           <br><br>
                                           Al igual que con el resto de ataques, los IDS/IPS nos ayudarn en la deteccin de estos ataques. La monitorizacin de la red nos permitir identificar los ataques, viendo picos donde se registran ms peticiones a un puerto determinado. Al contrario que en un escaneo de puertos, se puede observar que el ataque va dirigido a un puerto en concreto y que muchas de las peticiones van dirigidas.
                                           <br><br>
                                           Posibilidades para mitigar este tipo de ataques:
                                           <br><br>
                                           <ul type="square">
                                               <li>Edicin del archivo de configuracin para el demonio /etc/ssh/sshd_config:
                                                   <ul>
                                                       <li>No permitir el acceso mediante root. Esto nos permitir que cuando usen un diccionario para los usuarios, no puedan usar root. Para ello escribiremos en el fichero: <code>PERMITROOTLOGIN NO</code></li>
                                                       <li>Usar versiones seguras de los servicios. En el caso de SSH, la versin 1 del protocolo tiene muchas vulnerabilidades conocidas, por lo que debemos usar la 2. Escribimos en el fichero: <code>PROTOCOL 2</code></li>
                                                       <li>Modificar el nmero de segundos que la pantalla de login est activa, para que pasado el tiempo se cierre. Escribimos en el fichero: <code>LOGINGRACETIME 30</code></li>
                                                       <li>Modificar el nmero de intentos mximos que podemos fallar el login, despus de estos intentos fallidos se cerrar la conexin. Escribimos en el fichero: <code>MAXAUTHTRIES 3</code></li>
                                                   </ul>
                                                     
                                                   
                                               </li> 
                                               <br>
                                               <li>Desactivar contraseas, uso de RSA, clave pblica y privada.</li>
                                               <br>
                                               <li>Monitorizacin y bloqueo de IP mediante ACL</li>
                                               <br>
                                               <li>Portknocking. Consiste en esconder un puerto hasta que una secuencia de puertos ocurra. En Linux, el software ms utilizado es knockd. Un servidor knockd escucha todo el trfico que pasa por una interfaz Ethernet, buscando secuencias de puertos <br><br>El cliente enviar paquetes UDP o TCP a unos puertos especficos del servidor. No necesariamente tienen que estar esos puertos abiertos, ya que knockd escucha en la capa de enlace y ve todo el trfico. Cuando se detecta que la secuencia de puertos ocurre, knockd abrir el puerto del servicio que deseemos. Adems, en knockd.conf se puede configurar para que pasado un cierto tiempo, se vuelva a cerrar el puerto o que para una secuencia incorrecta tambin se cierre. Un ejemplo de port knocking sera el siguiente:<br><br>923:tcp, 8902:udp, 5558:tcp, 1099:udp, 68543:udp<br><br>Tras realizar esta secuencia de puertos, el puerto deseado se abrira.
                                                   Si esta secuencia no cambia, cualquiera que utilice un sniffer, puede descubrirla. Es recomendable utilizar un generador pseudoaleatorio de nmeros.</li>
                                               <br>
                                               <li>Mdulos PAM. Son una suite de libreras compartidas que permiten administrar la autenticacin de los usuarios. Podremos aplicar mecanismos de seguridad sin tener que aplicar los cambios y modificar cada aplicacin. Las configuraciones se pueden aadir a los ficheros del directorio /etc/pam.d. En ese directorio encontramos ficheros para los diferentes servicios.</li>
                                           </ul>
                                           
                                           <br><br>
                                                                                                                                                             
                                        </td>
                                    </tr>
                                </tbody>
                            </table> 
                            <footer class="panel-footer">Trabajo de fin de grado realizado por D. Sergio Sanz Ferrero en apoyo del Dr. Jess M Vegas Hernndez</footer>
                        </div> 
            

                    </div>

                
            
           
           

                    <div role="tabpanel" class="tab-pane fade" id="DoS">
                        <h2>Denegacin de servicio </h2>
                        <br>
                        <form method="post" action="Controlador"><button name="lanzar" type="submit" value="dos.sh" class="btn btn-primary active">Lanzar ataque</button></form>
                        <br>
                        <p>En seguridad informtica, un ataque de denegacin de servicio, tambin llamado ataque DoS (por sus siglas en ingls, Denial of Service), es un ataque a un sistema de computadoras o red que causa que un servicio o recurso sea inaccesible a los usuarios legtimos.
                           Normalmente provoca la prdida de la conectividad con la red por el consumo del ancho de banda de la red de la vctima o sobrecarga de los recursos computacionales del sistema atacado.</p>
                        <br>
                        <h4>TCP SYN Flood</h4>
                        <p>Es un mtodo de denegacin de servicio que afecta a hosts que corren procesos TCP. El ataque aprovecha el tiempo de espera despus de recibir un segmento SYN en un puerto que est en estado de escucha. Para entender cmo funciona un ataque de este tipo, necesitamos entender cmo se establece una conexin TCP. Una conexin TCP se establece con lo que comnmente se conoce como un "three-way handshake":</p>                        
                        <br>
                        <ul type="square">
                            <li>1 El cliente enva un paquete SYN para establecer una conexin TCP.</li>   
                            <li>2 El servidor recibe el paquete SYN, pasa a estado de SYN-RCVD y responde con un SYN+ACK.</li>       
                            <li>3 Finalmente, el cliente responde con un ACK.</li>
                        </ul>
                        <br>
                        <p>Sin embargo, si no se realiza el tercer paso, el servidor seguir esperando un ACK en estado de SYN-RCVD. Existe la posibilidad de no responder al SYN+ACK o de hacer "spoofing" de la direccin de origen como se muestra en la siguiente figura.</p>
                        <br>
                        <p>El ataque por inundacin SYN explota este comportamiento. El prsito de este ataque es enviar muchas paquetes SYN al servidor e ignorar los paquetes SYN+ACK devueltos. Esto provoca que el servidor se quede esperando por mltiples peticiones durante el tiempo configurado de esperay produce una sobrecarga en el servidor, ya que hay un nmero limitado de conexiones TCP concurrentes. Si el servidor llega al lmite, no se podrn aceptar nuevas conexiones.</p>
                        <br>
                        <img class="center-block" src="images/SYNFlood.jpeg" alt="SYN Flood" width="37%" height="30%">
                        <br>
                   
                        <h4>UDP/ICMP Flood</h4>
                        <p>UDP, al contrario que TCP, no necesita crear una sesin entre cliente y servidor, es decir, no hay ningn handshake. ICMP es otro caso en el que no se necesita crear una sesin. Suele ser usado para mandar mensajes de error e informacin operacional desde los dispositivos de red. </p>
                        <br>
                        <p>Ambos protocolos no explotan ninguna vulnerabilidad. Este ataque consiste simplemente en mandar paquetes continuamente a puertos aleatorios hasta que el servidor se sobrecargue intentando procesar todas las peticiones. Tambin se puede usar en combinacin con "spoofing". </p>
                        <br>
                        <p>Cuando se enva un paquete UDP en el cul no hay aplicaciones escuchando, como hemos visto anteriormente, el servidor tendr que responder con numerosos paquetes ICMP. </p>
                        <br>
                        <p>En un ataque de inundacin ICMP, se intercambiaran dos tipos de mensajes entre el cliente y el servidor, un ICMP Echo Request y un ICMP Echo Reply.</p>
                        <br>
                        
                        <h4>Ataque SMURF</h4>
                        <p>Un atacante elige un intermediario como amplificador. Enva una gran cantidad de paquetes ICMP a la direccin IP de broadcast de esos sitios intermediarios. La direccin sobre la que haremos "spoofing" es la de la vctima. Esto provocar que todos los dispositivos de la red manden ICMP Echo Replies a la vctima para sobrecargarla.</p>
                        <br>
                      
                        <img class="center-block" src="images/smurf.jpg" alt="SMURF" width="27%" height="40%" >
                   
                        
                        <br>
                        
                        <div class="table-responsive">          
                            <table class="table">
                              <thead>
                                <tr>
                                  <th>Lanzamiento</th>
                                </tr>
                              </thead>
                              <tbody>
                                <tr>
                                  <td>
                                      Para poder probar este tipo de ataques utilizaremos "hping3". Consiste en una herramienta de red capaz de enviar paquetes TCP/IP personalizados y de mostrar las rplicas del objetivo. Es til para poder probar firewalls, escneos de puertos, fragmentacin... Lanzaremos un TCP SYN DoS mediante:
                                      <br><br>
                                      <code>$ hping3 -S --flood -V  -p 80 157.88.123.102</code>
                                  </td>                        
                                </tr>           
                              </tbody>
                            </table>
                        </div>
                        
                        <div class="table-responsive">          
                            <table class="table">
                              <thead>
                                <tr>
                                  <th>Deteccin y defensa</th>
                                </tr>
                              </thead>
                              <tbody>
                                <tr>
                                  <td>
                                      Hay muchas estrategias para la mitigacin de este tipo de ataques, aunque ninguna es totalmente efectiva. Por supuesto, la mejor manera de ver estos ataques, que pueden ser identificados fcilmente, son utilizando IDS/ISP o monitorizando la red y aadiendo reglas de filtrado en el firewall, como por ejemplo evitando paquetes ICMP a nuestro servidor para evitar ICMP Flood o bloqueando una IP concreta. Podemos detectar un ataque de denegacin de servicio si encontramos un gran nmero de peticiones cuyo origen es la misma IP en un corto perodo de tiempo, el trfico que se produce es muy alto.
                                      <br><br>
                                      Es recomendable usar, proxies inversos o balanceadores de carga. El objetivo es, que aunque algn dispositivo de red o servidor se sobrecargue, se pueda seguir utilizando. Para ello tambin ser efectivo aadir redundancia en nuestra red y usar protocolos como HSRP o RSTP para alta disponibilidad. Tambin es importante la correcta configuracin de los servicios que ofrezca el servidor.
                                      <br><br>
                                      Existen ciertas configuraciones del kernel de Linux que nos permitir proteger nuestro servidor. Para ello modificaremos parmetros del fichero /etc/sysctl.conf, desde el cul sirve para pasar configuraciones al kernel en tiempo de ejecucin. Realizaremos estas modificaciones:
                                      <br>
                                      <ul type="square">
                                          <li>tcp_syncookies: para evitar ataques TCP SYN Flood. Cuando la cola de peticiones SYN se completa, el servidor responder con un paquete SYN-ACK como hace normalmente, pero creando un nmero de secuencia codificado con la IP de origen, la IP de destino, el puerto y un timestamp. As pues, la cola ya no ser necesaria ya que podr reconstruirse mediante el nmero de secuencia. Se activar esto mediante:<br><code>sysctl -w net.ipv4.tcp_syncookies=1</code></li>
                                          <li>ignore_broadcasts: para evitar ataques SMURF. Se desactivar la respuesta a las peticiones boradcast de tipo echo ICMP. Se activa:<br><code>sysctl -w net.ipv4.icmp_echo_ignore_broadcasts=1</code></li>
                                          <li>rp_filter: permite detectar el IP Spoofing comprobando que los paquetes que entran por una interfaz son alcanzables basndose en la direccin de orgien. Se activa con:<br><code>sysctl -w net.ipv4.conf.all.rp_filter=1</code></li>                                       
                                      </ul>
                                      <br><br>
                                      Anlogamente, se puede seguir la misma estrategia, realizando las configuraciones correspondientes en los routers de Cisco, basndose en los mismos principios que nos hemos basado antes.
                                      <br>
                                      <ul type="square">
                                          <li>Para evitar ataques ataques TCP SYN FLOOD usaremos TCP intercept. Es utilizado para interceptar y validar las solicitudes de conexin TCP. Se establece una conexin con el cliente en nombre del servidor de destino, si tiene xito se establece una conexin en nombre del cliente y se unen las dos conexiones. As, se evitan los intentos de conexin de hosts inalcanzables. Se utilizarn adems umbrales de tiempo de espera para detectar conexiones ilegtimas. </li>
                                          <li>Para evitar ataques SMURF, seleccionamos la interfaz del router por la que pueden llegar estos ataques y escribiremos el siguiente comando:<br><code>no ip directed-broadcast</code></li>
                                          <li>Reverse Path Forwarding para verificar que el origen de las peticiones es accesible. Evita las direcciones falsificadas, si la direccin de origen es falsa, el paquete se descarta.</li>
                                      </ul>
                                  </td>                        
                                </tr>           
                              </tbody>
                            </table>
                        </div>

                   
                        <footer class="panel-footer">Universidad de Valladolid. Trabajo de fin de grado realizado por D. Sergio Sanz Ferrero y Dr. Jess M Vegas Hernndez</footer>
                    </div>


                    <div role="tabpanel" class="tab-pane fade" id="escaneopuertos">
                        <h2>Escaneo de puertos</h2>
                        <br>
                        <form method="post" action="Controlador"><button name="lanzar" type="submit" value="nmap.sh" class="btn btn-primary active">Lanzar ataque</button></form>
                        <br>
                        <p>Nmap es una herramienta open-source cuyas  utilidades principales son el descubrimiento de redes y auditoras de seguridad. Es til tambin para administradores de redes y sistemas para mantener el inventario de los dispositivos, o monitorizacin de servicios y actividades de los hosts.Lo interesante de esta herramienta es la tabla de puertos que nos muestra la salida. Esta tabla muestra el estado, el nmero de puerto, el protocolo, el nombre de servicio y el estado.El estado puede ser:</p>
                        <ul type="square">
                            <li>Open: una aplicacin est escuchando en ese puerto</li>
                            <li>Filtered: un firewall, filtro  u otro obstculo de red est bloqueando ese puerto, por tanto Nmap no puede indicarnos si est abierto o est cerrado</li>
                            <li>Unfiltered: cuando responde a Nmap, pero no puede determinar si el puerto est abierto o cerrado</li>
                            <li>Closed: no hay aplicaciones escuchando en el puerto</li>
                        </ul>
                        <br>
                        <h4>TCP Syn Scan</h4>
                        <p>Es la tcnica ms utilizada. Se activa con la opci -sS. Escanea miles de puertos por segundo y es relativamente discreto, ya que nunca completa las conexiones TCP. Enva un paquete SYN, como si fuera a abrir una conexin real y luego espera la respuesta. Un SYN o ACK indica que el puerto est abierto, mientras que un RST(reinicio) indica que no se escucha. Si no se ha recibido nada o se ha recibido un paquete ICMP, indica que el puerto est filtrado.</p>
                        
                        <br>
                        <h4>UDP Scan</h4>
                        <p>La mayora de los servicios de Internet se ejecutan a travs del protocolo TCP. Pero existen servicios muy importantes y vulnerables como DNS, SNMP o DHCP que utilizan el protocolo UDP. Este escaneo se activa con la opcin -sU y se puede combinar con el escaneo TCP. Se enva un paquete UDP, normalmente con contenido vaco, a menos que se especifique. Si devuelve un cdigo ICMP(tipo 3, cdigo 3) el puerto est cerrado. Otros errores ICMP indican el puerto como filtrado. Si no se recibe nada, significa que el puerto est abierto o que se ha bloqueado la comunicacin.La dificultad de este escaneo es hacerlo rpidamente, ya que los puertos abiertos o filtrados no mandan respuesta y deja a Nmap en espera.</p>
                        
                        <br>
                        <div class="table-responsive">  
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Lanzamiento</th>                                
                                    </tr>   
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>
                                            La sintaxis de Nmap es:
                                            <br>
                                            nmap [Scan Type...] [Options] {target specification}
                                            <br><br>
                                            Lanzaremos un escaneo TCP SYN con la opcin -A, que nos mostrar el SO, la versin detectada y la traceroute:
                                            <br>
                                            <code>$ nmap -sS -A 157.88.123.102</code> 
                                        </td>
                                    </tr>
                                </tbody>
                            </table>                          
                        </div>
                        
                        <div class="table-responsive">  
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Deteccin y defensa</th>                                
                                    </tr>   
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>
                                            La nica forma de evitar un escaneo de puertos es bloquear todo el trfico que llega a la red desde el exterior. En nuestro caso, no podemos bloquear todo el trfico, estamos ofreciendo servicios al exterior y si lo bloqueamos no podrn ser usados. En cualquier entorno de laboratorio, esto es una situacin que no se va a dar.
                                            Por lo tanto, estamos expuestos a recibir constantemente escaneos de puertos. No nos tendremos que centrar en evitar estos, nos centraremos en proteger el acceso a los servicios.
                                            <br><br>
                                            Existe la posibilidad de monitorizar continuamente el estado de la red y tener un IDS para detectar este tipo de ataques. Cuando observemos actividad malicioso y continuada por parte de una o varias IPs, podremos bloquear esta IP en el firewall y evitar que puedan continuar hacindolo.
                                            <br><br>
                                            Al lanzar el ataque se puede observar en el estado de la red un pico de peticiones que provienen del mismo origen. En este tipo de ataques se observar que las peticiones se realizarn a mltiples puertos, en vez de a un puerto concreto, como puede ocurrir en un ataque de fuerza bruta. Es una distribucin uniforme y no se ha dirigido a ningn puerto en concreto. Podremos analizar los logs para ver que puertos ha detectado como abiertos. Para ello, nos fijaremos en los flags de los paquetes TCP. Como hemos visto en la descripcin del ataque, segn el tipo de flag visto en los logs, podremos detectar si un puerto est abierto, cerrado, filtrado o sin filtrar.
                                        </td>
                                    </tr>
                                </tbody>
                            </table>                          
                        </div>    
                       
                        <footer class="panel-footer">Universidad de Valladolid. Trabajo de fin de grado realizado por D. Sergio Sanz Ferrero y Dr. Jess M Vegas Hernndez</footer>
                    </div>
                    
                    <div role="tabpanel" class="tab-pane fade" id="spoofing">
                        <h2>Spoofing</h2>
                        <br>
                        <h4>Man In The Middle</h4>
                        <p>El atacante se situar en el medio de una comunicacin entre cliente y servidor. Por lo tanto, toda comunicacin entre ambos extremos ser capturada por el atacante. Una vez situado en el medio, podr llevar a cabo multitud de ataques. </p>
                        <br>
                        <h4>MAC Flooding</h4>                       
                        <p>Como ya sabemos, ARP es un protocolo de la capa de enlace. Su propsito general es resolver una IP en una direccin MAC. Un switch dispone de una memoria interna, conocida como CAM (Content-Adressable Memory) donde asigna puertos a direcciones MAC. Cuando llega una trama a un switch y se desconoce el destino, porque es la primera vez que llega, o ha expirado, se enviar por todos los puertos de la VLAN excepto por el que fue recibido. Gracias a esto podr enviar el paquete por un puerto nico. </p>
                        <br>
                        <p>La idea de este ataque consiste en envar una gran cantidad de rplicas de ARP para sobrecargarlo, llenando la tabla CAM del switch de asignaciones , y que pase a modo hub. Esto quiere decir que todo el trfico que le llegue, lo mandar a todos los hosts de la red. Un atacante podra ahora escuchar todo el trfico de la red mediante un sniffer.</p>
                        <div class="table-responsive">  
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Lanzamiento</th>                                
                                    </tr>   
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>
                                            LLevaremos a cabo un ataque MITM mediante ARP Spoofing dentro de nuestra red local. Los equipos involucrados sern de la VLAN 30, es decir los de la subred 192.168.30.0/24. Estas sern las IPs de los equipos involucrados:
                                            <ul type="square">
                                                <li>Atacante: 192.168.30.10 </li>
                                                <li>Vctima: 192.168.30.20</li>
                                                <li>Default Gateway: 192.168.30.1</li>
                                            </ul>
                                            <br>                                                                       
                                            Para realizar el spoofing usaremos la herramienta Arpspoof del paquete Dsniff. Inundar la red con tramas ARP para que todas las maquinas actualicen su tabla. El objetivo es que la vctima en vez de enviar los paquetes al Default Gateway, los enve a la mquina del atacante. Para ello cambiaremos la direccin MAC asociada a la IP del Default Gateway por la direccin MAC del atacante.   
                                            <br><br>
                                            <code>$ arpspoof -I eth0 -t 192.168.30.20 192.168.30.1</code>
                                            <br>
                                            <code>$ arpspoof -I eth0 -t 192.168.30.1 192.168.30.20</code>
                                            <br><br>
                                            Una vez hecho el envenenamiento de su tabla ARP, podremos observar que ahora cada vez que la vctima enva los datos, pasarn por el atacante. Si consultamos la tabla ARP de la vctima observamos que ambas direcciones tienen la misma direccin MAC.
                                            
                                            
                                            <pre>? (192.168.30.1) at 00:1c:42:60:bc:a0  [ether] on eth0
? (192.168.30.10) at 00:1c:42:60:bc:a0 [ether] on eth0</pre>
                                            
                                            Ahora podremos realizar otro tipo de ataques como es el de denegacin de servicio, DNS spoofing...La herramienta que se suele usar para realizar el ARP spoofing y posteriormente llevar a cabo los otros ataces es Ettercap. 
                                            <br><br>
                                            No podremos lanzar el ataque desde esta interfaz web, pues es un ataque que se realiza desde el interior y solo monitorizamos el trfico que proviene del exterior. An as resulta interesante ananalizar el trfico que se genera.
                                            <br><br>
                                            <img class="center-block" src="images/arpspoof.png" alt="Spoofing" width="100%" height="60%">
                                            <br>
                                            De esta forma, la subred se inunda con paquetes ARP falsificados en los que la direccin MAC del default gateway ser la del atacante y as todo el trfico de la subred pasar por este.
                                            <br>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>                          
                        </div>
                        
                        <div class="table-responsive">  
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th>Deteccin y defensa</th>                                
                                    </tr>   
                                </thead>
                                <tbody>
                                    <tr>
                                        <td>  
                                            La mejor forma de detectar este tipo de ataques es mediante un IDS o un IPS. Tambin es conveniente revisar las tablas ARP para ver si a dos IPs distintas le corresponde la misma direccin MAC y as detectarlo.
                                            <br><br>
                                            Existen mecanismos de autenticacin para prevenirlo y as tener a un usuario siempre identificado. Tambin puede ser usado ARP esttico, de tal forma que sea imposible ninguna alteracin, pero no es recomendable para redes grandes. Sin duda, la tcnica ms usada en empresas u organizaciones con redes grandes es usar una VPN.
                                            <br><br>
                                            En algunos switches modernos de Cisco tambin existe el DAI (Dynamic ARP Inspection) para prevenir ataques relacionados con el protocolo ARP. Al activarlo, intercepta todas las peticiones y respuestas ARP y verifica la autenticidad antes de actualizar la tabla o de reenvar los paquetes a los destinos. Nosotros no podremos implementar este mtodo ya que el que hemos utilizado se trata de uno ms antiguo, sin esta caracterstica.
                                            
                                        </td>
                                    </tr>
                                </tbody>
                            </table> 
                           
                        </div> 
            
                        <footer class="panel-footer">Universidad de Valladolid. Trabajo de fin de grado realizado por D. Sergio Sanz Ferrero y Dr. Jess M Vegas Hernndez</footer>
                    </div>
            </div>
       
        
        </div>
        
        <div class="modal fade" id="myModal" role="dialog">
            <div class="modal-dialog">

              <!-- Modal content-->
              <div class="modal-content">
                <div class="modal-header">
                  <button type="button" class="close" data-dismiss="modal">&times;</button>
                  <h4 class="modal-title">About</h4>
                </div>
                <div class="modal-body">
                  <p>Trabajo de fin de grado realizado por D. Sergio Sanz Ferrero y Dr. Jess M Vegas Hernndez.</p>
                  <br>
                  <p>Esta interfaz web pretenda ilustrar de una forma didctica las principales vulnerabilidades presentes en una infraestructura red. Para ello se incluye una descripcin y varias soluciones para poder detectar y mitigar estos ataques. </p>
                  <br>
                  <p>Se podrn lanzar estos ataques desde la interfaz web para analizar el trfico que se genera y su repercusin sobre la red 157.88.123.102.</p>
                  <br>
                  <p>Universidad de Valladolid</p>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
                </div>
              </div>

        </div>
  </div>
          
  </body>
</html>
